;
;***********************
;     TEST LED 8*20    *
;***********************

        CPU  "Z80.TBL"
        HOF  "INT8"

CTRL:   EQU  23H
DATA:   EQU  20H
SCAN:   EQU  21H
CLOCK:  EQU  22H

        ORG  2000H
;
STR:    LD   A,80H
        OUT  (CTRL),A
        LD   A,0FFH
        OUT  (SCAN),A
        LD   A,0
        OUT  (DATA),A
        LD   A,0
        OUT  (CLOCK),A
        LD   A,0FFH
        OUT  (CLOCK),A

STR0:   CALL DEL
        CALL DEL
        CALL DEL

        LD   C,20
        LD   HL,DAT
ST3:    LD   A,(HL)
        OUT  (SCAN),A

        LD   B,8
        LD   A,1
ST1:    OUT  (DATA),A

        PUSH AF
        LD   A,0
        OUT  (CLOCK),A

ST11:   DEC  A
        JR   NZ,ST11

        LD   A,0FFH
        OUT  (CLOCK),A

        CALL DEL
        POP  AF

        RLCA
        DJNZ ST1
;
        INC  HL
        DEC  C
        JR   NZ,ST3
;
        LD   HL,DAT
        LD   B,20
L0:     LD   A,(HL)
        OUT  (SCAN),A
        LD   A,0FFH
        OUT  (DATA),A
        LD   A,0
        OUT  (CLOCK),A
L1:     DEC  A
        JR   NZ,L1
        LD   A,0FFH
        OUT  (CLOCK),A

        CALL DEL
        INC  HL
        DJNZ L0
;
        CALL DEL
        CALL DEL
        CALL DEL
;
;/*****************/

        LD   IX,TAB_J
J0:     LD   C,60H
JX1:    LD   HL,DAT
        LD   B,20
JX0:    LD   A,(HL)
        OUT  (SCAN),A
        LD   A,(IX+0)
        OUT  (DATA),A
        LD   A,0
        OUT  (CLOCK),A
        LD   A,0FFH
        OUT  (CLOCK),A

        LD   A,20H
JX2:    DEC  A
        JR   NZ,JX2

        INC  HL
        DJNZ JX0
        DEC  C
        JR   NZ,JX1
;
        LD   A,0FFH
        OUT  (SCAN),A
        INC  IX
        LD   A,(IX+0)
        OR   A
        JR   NZ,J0

        LD   A,0FFH
        OUT  (CLOCK),A
        CALL DEL
        CALL DEL
        CALL DEL


;/*-----------*/

        LD   C,80H
XX1:    LD   HL,DAT
        LD   B,20
LL0:    LD   A,(HL)
        OUT  (SCAN),A
        LD   A,0FFH
        OUT  (DATA),A
        LD   A,0
        OUT  (CLOCK),A
LL1:    DEC  A
        JR   NZ,LL1
        LD   A,0FFH
        OUT  (CLOCK),A

        LD   A,20H
LL2:    DEC  A
        JR   NZ,LL2

        INC  HL
        DJNZ LL0
        DEC  C
        JR   NZ,XX1
;
        LD   A,0FFH
        OUT  (SCAN),A
        JP   STR0
;
DEL:    PUSH HL
        LD   HL,4000H
DEL1:   DEC  HL
        LD   A,H
        OR   L
        JR   NZ,DEL1
        POP  HL
        RET
;
DAT:    DFB  0F0H,0F1H,0F2H,0F3H,0F4H,0F5H,0F6H,0F7H,0F8H,0F9H
        DFB  0FH,1FH,2FH,3FH,4FH,5FH,6FH,7FH,8FH,9FH
;
TAB_J:  DFB  80H,40H,20H,10H,8,4,2,1,0

        END




